//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  OrangeRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  LimeGreen
#property indicator_width1  2

extern ENUM_TIMEFRAMES TimeFrame    = PERIOD_CURRENT;
extern int             DMIM_period1 = 5;
extern int             DMIM_period2 = 8;
extern int             DMIM_period3 = 14;
extern double          LevelUp      = 50;
extern double          LevelDown    = 10;
extern bool            Interpolate  = true;

double buff1[];
double buff2[];
double buff3[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buff1);
   SetIndexBuffer(1,buff2);
   SetIndexBuffer(2,buff3);
      SetLevelValue(0,LevelUp);
      SetLevelValue(1,LevelDown);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" 3 x Wilders\' DMI ("+DMIM_period1+","+DMIM_period2+","+DMIM_period3+")");
   return(0);
}
int start()
{
   int countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
           if (returnBars) { buff1[0] = MathMin(limit+1,Bars-1); return(0); }
           if (TimeFrame!=_Period)
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-98,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     buff1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMIM_period1,DMIM_period2,DMIM_period3,0,y);
                     buff2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMIM_period1,DMIM_period2,DMIM_period3,1,y);
                     buff3[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMIM_period1,DMIM_period2,DMIM_period3,2,y);
                     if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //

                     datetime time = iTime(NULL,TimeFrame,y);
                        for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                        for(int k = 1; k < n; k++)
                        {
                           buff1[i+k] = buff1[i] + (buff1[i+n]-buff1[i])*k/n;
                           buff2[i+k] = buff2[i] + (buff2[i+n]-buff2[i])*k/n;
                           buff3[i+k] = buff3[i] + (buff3[i+n]-buff3[i])*k/n;
                        }
               }
               return(0);
           }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double adx  = 0;
      double adxr = 0;
      double dip  = 0;
      double dim  = 0;
         iWilders(DMIM_period1,adx,adxr,dip,dim,i,0); buff1[i] = dim;
         iWilders(DMIM_period2,adx,adxr,dip,dim,i,1); buff2[i] = dim;
         iWilders(DMIM_period3,adx,adxr,dip,dim,i,2); buff3[i] = dim;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workADX[][21];
#define _DIp        0
#define _DIm        1
#define _ADX        2
#define _ADXR       3
#define _averageDIp 4
#define _averageDIm 5
#define _averageTR  6

void iWilders(int DMI_Length, double &tADX, double &tADXR, double &tDIp, double &tDIm, int i, int instanceNo)
{
   if (ArrayRange(workADX,0)!=Bars) ArrayResize(workADX,Bars); instanceNo *= 7; int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   double sf = (DMI_Length-1.0)/DMI_Length;

         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i] - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            workADX[r][instanceNo+_averageDIp] = sf*workADX[r-1][instanceNo+_averageDIp] + plusDM;
            workADX[r][instanceNo+_averageDIm] = sf*workADX[r-1][instanceNo+_averageDIm] + minusDM;
            workADX[r][instanceNo+_averageTR]  = sf*workADX[r-1][instanceNo+_averageTR]  + currTR;

         //
         //
         //
         //
         //
                  
            workADX[r][instanceNo+_DIp] = 0.00;                   
            workADX[r][instanceNo+_DIm] = 0.00;                   
            if (workADX[r][instanceNo+_averageTR] > 0)
               {              
                  workADX[r][instanceNo+_DIp] = 100.00 * workADX[r][instanceNo+_averageDIp]/workADX[r][instanceNo+_averageTR];
                  workADX[r][instanceNo+_DIm] = 100.00 * workADX[r][instanceNo+_averageDIm]/workADX[r][instanceNo+_averageTR];
               }            
               double DX;
               if((workADX[r][instanceNo+_DIp] + workADX[r][instanceNo+_DIm])>0) 
                    DX = 100*MathAbs(workADX[r][instanceNo+_DIp] - workADX[r][instanceNo+_DIm])/(workADX[r][instanceNo+_DIp] + workADX[r][instanceNo+_DIm]); 
               else DX = 0.00;
               workADX[r][instanceNo+_ADX]       = sf*workADX[r-1][instanceNo+_ADX] + DX/DMI_Length; 
               workADX[r][instanceNo+_ADXR]      = 0.5*(workADX[r][instanceNo+_ADX] + workADX[r-DMI_Length][instanceNo+_ADX]);
   //
   //
   //
   //
   //
   
   tADX  = workADX[r][instanceNo+_ADX];
   tADXR = workADX[r][instanceNo+_ADXR];
   tDIp  = workADX[r][instanceNo+_DIp];
   tDIm  = workADX[r][instanceNo+_DIm];
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}